/* IODEV.H                                                                   */


/*---------------------------------------------------------------------------*/
/* Macros to extract parts of DevCode arguments                              */

#define IO_DEVICE(x)  ((x & 0x0F00) >> 8)
#define IO_CHANNEL(x) ((x & 0x00F0) >> 4)

#define IO_BITID(x)   (x & 0x000F)
#define IO_BITMASK(x) (1 << (x & 0x000f))

#define NODEVSPEC    0x8000            /* no device specified (or error)     */
#define NOCHANSPEC   0x4000            /* no channel specified               */
#define NOBITSPEC    0x2000            /* no bit specified                   */

/*---------------------------------------------------------------------------*/
/* Galactic constants                                                        */
/* Device-related constants are in IODEV.D2 to keep them together            */

#define IOBASEADDR 0xE000              /* RTC-IO board base address          */
#define IOALTADDR  0xE040              /* offset to second board address     */

#define ADC_EOC   INT1                 /* ADC end of conversion input        */
#define CLK_TICK  INT0                 /* interrupt from real time clock     */

#define ADC_NORMAL   0                 /* for timing ADC conversions w/EOC   */
#define ADC_TIMED    1                 /* for timing with fixed delay        */
