/* IRGATE.H -- IR gateway constants                                          */

/*---------------------------------------------------------------------------*/
/* Debugging outputs                                                         */
/* The serial, timer, and IR flags are controlled by compile-time switches   */
/*  so we can use them as output bits from the command line                  */

#define MAINFLAG   P1.7                /* heartbeat -- one change/second     */
#define SERIALFLAG P1.6                /* high during serial interrupts      */
#define TIMERFLAG  P1.5                /* high for timer ticks               */
#define IRFLAG     P1.4                /* high for IR receiver interrupts    */
/* net address bits are in here */
#define MANUALMODE P1.0                /* INPUT low -> manual mode on reset  */

#define TRACECHAR(x) putch(x)          /* how to output tracing stuff        */

#ifndef LOGGGING                       /* define LOGGING to enable outputs   */
#define TRACECHAR(x)
#endif


/*---------------------------------------------------------------------------*/
/* Bit masks for ErrFlags to monitor internal glitches                       */
/* They're in either assembler or C syntax as needed...                      */

#define ERR_T0STATE     $02            /* bad T0State variable               */

/*---------------------------------------------------------------------------*/
/* Enables for various reporting outputs                                     */

#define REPORT_NONE     0x00           /* disable all reports                */
#define REPORT_REC      0x01           /* show receiever messages            */
#define REPORT_TRANS    0x02           /* show transmitter messages          */
#define REPORT_POLL     0x04           /* show badge polling events          */

/*---------------------------------------------------------------------------*/
/* Stack initialization code                                                 */

#define MAXSTACK        127            /* last valid IRAM address for stack  */
                                       /* decimal for C/asm use...           */
