/* LCD.H                                                                     */


/*---------------------------------------------------------------------------*/
/* I/O bit locations                                                         */

#define LCD_RS       T1                /* 0 = command  1 = data              */
#define LCD_RW       INT0              /* 0 = write    1 = read              */
#define LCD_ENABLE   INT1              /* 0 = disable  1 = latch/enable      */

#define LCD_PORT     P1                /* port for data bits                 */

/*---------------------------------------------------------------------------*/
/* Constants                                                                 */

#define LCDCURSOFF   0                             /* for LCDSelCursor       */
#define LCDCURSON    1

#define LCDDISPOFF   0                             /* for LCDSelDisplay      */
#define LCDDISPON    1

                                                   /* for LCDSendByte        */
#define LCDCMD       0x00                          /* bit 0 sets cmd/data    */
#define LCDDATA      0x01
#define LCDFORCE     0x02                          /* bit 1 sets wait/force  */
#define LCDWAIT      0x00                          /* no bit set!            */

#define LCD_VSCROLL  0x01                          /* scroll after last line */
#define LCD_BLANKING 0x02                          /* blank during scrolls   */
#define LCD_CRLF     0x04                          /* force CR after \n      */
#define LCD_HWRAP    0x08                          /* wrap at end of line    */
#define LCD_DESTBS   0x10                          /* erase char on BS       */

