* FFISFNS.ASM
* Firmware Furnace replacement for ISFUNS.ASM
*
* Use SLIB to replace ISFUNS.ASM in COMPACT.LIB with this file:
*
*  CD C:\MC51\LIB
*  SLIB i=compact.lib r=isfuns.asm a=ffisfuns.asm
*

*------------------------
* Lookup table for character classification functions
* Bits define classes thusly:
*  7 -
*  6 - blank (0x20 only)
*  5 - space (0x09 - 0x0d or blank char)
*  4 - numeric ("0".."9")
*  3 - hexadecimal digit ("0".."9", "A".."F", "a".."f")
*  2 - lowercase ("a".."z")
*  1 - uppercase ("A".."Z")
*  0 - punctuation
* High bit of incoming character is forced off...

?_BLANK       EQU       $40
?_SPACE       EQU       $20
?_DIGIT       EQU       $10
?_HEXIT       EQU       $08
?_LOWER       EQU       $04
?_UPPER       EQU       $02
?_PUNCT       EQU       $01

*                        .BSDHLUP
?classes      EQU       *
              DB        %00000000           ; 00 NUL
              DB        %00000000           ; 01 SOH
              DB        %00000000           ; 02 STX
              DB        %00000000           ; 03 ETX
              DB        %00000000           ; 04 EOT
              DB        %00000000           ; 05 ENQ
              DB        %00000000           ; 06 ACK
              DB        %00000000           ; 07 BEL
              DB        %00000000           ; 08 BS
              DB        %00100000           ; 09 HT
              DB        %00100000           ; 0A LF
              DB        %00100000           ; 0B VT
              DB        %00100000           ; 0C FF
              DB        %00100000           ; 0D CR
              DB        %00000000           ; 0E SO
              DB        %00000000           ; 0F SI
              DB        %00000000           ; 10 DLE
              DB        %00000000           ; 11 DC1
              DB        %00000000           ; 12 DC2
              DB        %00000000           ; 13 DC3
              DB        %00000000           ; 14 DC4
              DB        %00000000           ; 15 NAK
              DB        %00000000           ; 16 WYN
              DB        %00000000           ; 17 ETB
              DB        %00000000           ; 18 CAN
              DB        %00000000           ; 19 EM
              DB        %00000000           ; 1A SUB
              DB        %00000000           ; 1B ESC
              DB        %00000000           ; 1C FS
              DB        %00000000           ; 1D GS
              DB        %00000000           ; 1E RS
              DB        %00000000           ; 1F US
              DB        %01100000           ; 20 blank
              DB        %00000001           ; 21 !
              DB        %00000001           ; 22 double quote
              DB        %00000001           ; 23 #
              DB        %00000001           ; 24 $
              DB        %00000001           ; 25 %
              DB        %00000001           ; 26 &
              DB        %00000001           ; 27 single quote
              DB        %00000001           ; 28 (
              DB        %00000001           ; 29 )
              DB        %00000001           ; 2A *
              DB        %00000001           ; 2B +
              DB        %00000001           ; 2C ,
              DB        %00000001           ; 2D -
              DB        %00000001           ; 2E .
              DB        %00000001           ; 2F /
              DB        %00011000           ; 30 0
              DB        %00011000           ; 31 1
              DB        %00011000           ; 32 2
              DB        %00011000           ; 33 3
              DB        %00011000           ; 34 4
              DB        %00011000           ; 35 5
              DB        %00011000           ; 36 6
              DB        %00011000           ; 37 7
              DB        %00011000           ; 38 8
              DB        %00011000           ; 39 9
              DB        %00000001           ; 3A :
              DB        %00000001           ; 3B ;
              DB        %00000001           ; 3C <
              DB        %00000001           ; 3D =
              DB        %00000001           ; 3E >
              DB        %00000001           ; 3F ?
              DB        %00000001           ; 40 @
              DB        %00001010           ; 41 A
              DB        %00001010           ; 42 B
              DB        %00001010           ; 43 C
              DB        %00001010           ; 44 D
              DB        %00001010           ; 45 E
              DB        %00001010           ; 46 F
              DB        %00000010           ; 47 G
              DB        %00000010           ; 48 H
              DB        %00000010           ; 49 I
              DB        %00000010           ; 4A J
              DB        %00000010           ; 4B K
              DB        %00000010           ; 4C L
              DB        %00000010           ; 4D M
              DB        %00000010           ; 4E N
              DB        %00000010           ; 4F O
              DB        %00000010           ; 50 P
              DB        %00000010           ; 51 Q
              DB        %00000010           ; 52 R
              DB        %00000010           ; 53 S
              DB        %00000010           ; 54 T
              DB        %00000010           ; 55 U
              DB        %00000010           ; 56 V
              DB        %00000010           ; 57 W
              DB        %00000010           ; 58 X
              DB        %00000010           ; 59 Y
              DB        %00000010           ; 5A Z
              DB        %00000001           ; 5B [
              DB        %00000001           ; 5C \
              DB        %00000001           ; 5D ]
              DB        %00000001           ; 5E ^
              DB        %00000001           ; 5F _
              DB        %00000001           ; 60 `
              DB        %00001100           ; 61 a
              DB        %00001100           ; 62 b
              DB        %00001100           ; 63 c
              DB        %00001100           ; 64 d
              DB        %00001100           ; 65 e
              DB        %00001100           ; 66 f
              DB        %00000100           ; 67 g
              DB        %00000100           ; 68 h
              DB        %00000100           ; 69 i
              DB        %00000100           ; 6A j
              DB        %00000100           ; 6B k
              DB        %00000100           ; 6C l
              DB        %00000100           ; 6D m
              DB        %00000100           ; 6E n
              DB        %00000100           ; 6F o
              DB        %00000100           ; 70 p
              DB        %00000100           ; 71 q
              DB        %00000100           ; 72 r
              DB        %00000100           ; 73 s
              DB        %00000100           ; 74 t
              DB        %00000100           ; 75 u
              DB        %00000100           ; 76 v
              DB        %00000100           ; 77 w
              DB        %00000100           ; 78 x
              DB        %00000100           ; 79 y
              DB        %00000100           ; 7A z
              DB        %00000001           ; 7B {
              DB        %00000001           ; 7C |
              DB        %00000001           ; 7D }
              DB        %00000001           ; 7E ~
              DB        %00000000           ; 7F RUBOUT

*--- generic routine to return 1 if char is in class, 0 otherwise
*    presumes it is JMPed to from C entry point with arg on stack
*    B contains mask of acceptable classes
*    F0FLAG (PSW.5) is set to flip the results

?class0       EQU       *                   ; common entry for most routines
              CLR       PSW.5

?class        EQU       *                   ; entry with F0 set up
              MOV       R0,#-5              ; set up ptr to arg
              LCALL     ?auto0
              MOV       A,[R0]              ; fetch from stack
              MOV       DPTR,#?classes
              CLR       A.7                 ; ASCII-ize it by fiat
              MOVC      A,[A+DPTR]          ; fetch class entry

              ANL       A,B                 ; mask to get values to test
              JZ        ?clno               ; if no match, false is set up
              MOV       A,#1                ; set true value
?clno         EQU       *

              MOV       C,PSW.5             ; need to flip the answer?
              MOV       B,#0
              MOV       B.0,C
              XRL       A,B                 ; wish there was an XRL bit op!

              MOV       B,#0                ; turn off high byte
              RET


*-------------
* Entry points for C functions

isascii       EQU       *
              MOV       R0,#-5              ; set up ptr to arg
              LCALL     ?auto0
              MOV       A,[R0]              ; fetch from stack
              MOV       C,A.7               ; high bit tells the tale
              CPL       C                   ;  ... zero means ASCII is true
              CLR       A                   ; assume false
              MOV       B,A
              MOV       A.0,C               ; but now make it right
              RET

isupper       EQU       *
              MOV       B,#?_UPPER
              SJMP      ?class0

islower       EQU       *
              MOV       B,#?_LOWER
              SJMP      ?class0

isalpha       EQU       *
              MOV       B,#?_UPPER+?_LOWER
              SJMP      ?class0

isalnum       EQU       *
              MOV       B,#?_UPPER+?_LOWER+?_DIGIT
              SJMP      ?class0

isgraph       EQU       *                   ; isprint w/o blank space
              MOV       B,#?_UPPER+?_LOWER+?_DIGIT+?_PUNCT
              SJMP      ?class0

isprint       EQU       *                   ; inverse of iscntrl
              MOV       B,#?_LOWER+?_UPPER+?_DIGIT+?_PUNCT+?_BLANK
              SJMP      ?class0

iscntrl       EQU       *                   ; inverse of isprint
              SETB      PSW.5
              MOV       B,#?_UPPER+?_LOWER+?_DIGIT+?_PUNCT+?_BLANK
              SJMP      ?class

isdigit       EQU       *
              MOV       B,#?_DIGIT
              SJMP      ?class0

isxdigit      EQU       *
              MOV       B,#?_HEXIT
              SJMP      ?class0

ispunct       EQU       *
              MOV       B,#?_PUNCT
              SJMP      ?class0

isspace       EQU       *
              MOV       B,#?_SPACE
              SJMP      ?class0

