/* CONSOLE.H -- serial I/O constants                                         */

/*---------------------------------------------------------------------------*/
/* Galactic serial and console constants                                     */
/* the magic number 28800 is 11.0592 MHz/(12*32)                             */

#define SMOD_BIT     1                 /* make sure it matches reality!      */
#define SERIALRATE   9600              /* serial port data rate              */

#define T1RELOAD     (-(SMOD_BIT+1)*(28800/SERIALRATE))

#define INRINGSIZE    250              /* must be <= 254 to avoid wraps      */
#define OUTRINGSIZE   250              /* ditto                              */

#define NET_ENABLE   T0                /* network transmitter enable bit     */

/*--- useful character definitions                                           */
/*    these are in decimal so as to be useful in either C or assembler       */

#define CANCEL    3
#define BELL      7
#define BS        8
#define CR        13
#define LF        10
#define FORMFEED  12
#define ESC       27
#define BLANK     ' '
#define DEL       127

#define XON       17
#define XOFF      19

#ifndef EOF
#define EOF -1
#endif

